class Item

  include MongoMapper::Document
  
  key :_type, String
  
  key :name, String, :required => true, :index => true
  key :parent_item_name, String, :required => true, :index => true

  key_i18n :title, String, :required => true
   
  key :position, Integer, :required => true
  key :is_published, Boolean, :required => true, :default => true, :index => true
  
  before_validation :setup_default_value
 
  def self.find_by_name(item_name)
    Item.find(:first, :conditions => { :name => item_name, :is_published => true })
  end
     
  protected
        
  def setup_default_value
    if self.position.blank?
      max_page = Page.find(:last, :order => 'position')
      self.position = (max_page)? max_page.position.to_i + 1 : 1
    end
    
    if self.parent_item_name.blank?
      self.parent_item_name = "root"
    end
  end
    
end